﻿using C1.Xamarin.Forms.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Xamarin.Forms;

namespace FlexGridConditional
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();

            //use custom cell factory
            flexGrid.CellFactory = new CustomCellFactory();

            //applying ItemsSource
            flexGrid.ItemsSource = GetItemsSource();
        }

        //sample data
        private IEnumerable<ProtListWarehouseUldDataModel> GetItemsSource()
        {
            var data = new ObservableCollection<ProtListWarehouseUldDataModel>();

            Random rnd = new Random();
            for (int i = 0; i < 20; i++)
            {
                data.Add(new ProtListWarehouseUldDataModel($"ULD_EQP_NR {i}", $"ULD_EQP_NR {i}", $"ULD_EQP_NR {i}", rnd.Next(1, 10)));
            }

            return data;
        }
    }

    //custom cell factort
    class CustomCellFactory: GridCellFactory
    {
        //override PrepareCell method
        public override void PrepareCell(GridCellType cellType, GridCellRange range, GridCellView cell)
        {
            //call base class method
            base.PrepareCell(cellType, range, cell);

            //if data cell
            if(cellType == GridCellType.Cell)
            {
                //get the data item
                var dataItem = Grid.Rows[range.Row].DataItem as ProtListWarehouseUldDataModel;

                //update row color as per cell value
                cell.BackgroundColor = dataItem.NUM_PKG > 4 ? Color.Green : Color.Red;
            }
        }
    }

    //ViewModel class
    public class ProtListWarehouseUldDataModel
    {
        public ProtListWarehouseUldDataModel(string uLD_EQP_NR, string sC_NR, string sHP_WHS_LOC_DES_TXT, int nUM_PKG)
        {
            ULD_EQP_NR = uLD_EQP_NR;
            SC_NR = sC_NR;
            SHP_WHS_LOC_DES_TXT = sHP_WHS_LOC_DES_TXT;
            NUM_PKG = nUM_PKG;
        }
        public string ULD_EQP_NR { get; set; }
        public string SC_NR { get; set; }
        public string SHP_WHS_LOC_DES_TXT { get; set; }
        public int NUM_PKG { get; set; }
    }
}
